/* INSJUMP.C Program to put the restart jump in the ROM   */

#include <stdio.h>
#include <mem.h>
#include <fcntl.h>
#include <string.h>

  typedef unsigned char byte;

  byte  Jump[] = "\xEA\x90\x0\x0\x0That's all!";    /* JMP FAR, abs 0x00:90 */

  byte  IOBuffer[4096];

  int       BinFileIn;
  int       BinFileOut;

  unsigned  long total_bytes;
  unsigned  long rom_size;
  int       bytes_read, iob;

void main(int argc, char *argv[])
{
register int  i;

  if (argc < 3) 
     {
     printf("Usage: insjump infile outfile\n");
     exit(1);
     }

  if ((BinFileIn = open(argv[1],O_BINARY | O_RDONLY)) < 0) 
     {
     printf("Couldn't open %s \n",argv[1]);
     exit(1);
     }

  if((BinFileOut = _creat(argv[2],0)) < 0 ) 
	 {
    printf("Couldn't open temp file for rewriting\n",argv[1]);
    exit(1);
	 }

  rom_size = 16384;
  total_bytes = 0;
  iob = sizeof(IOBuffer);

  do 
    {
    if (!eof(BinFileIn)) 
       {
       bytes_read = read(BinFileIn,IOBuffer,iob);
        /* printf("%d  bytes read\n",bytes_read); */
       }
    else 
    bytes_read = 0;

    if (bytes_read != iob)  /* fill unused with FF's  */
       memset(&IOBuffer[bytes_read],0xFF,iob-bytes_read);

    total_bytes += iob;

    if (total_bytes == rom_size) /* last block -- put in jump */
       {
       for (i=0; i<16; i++)
	  IOBuffer[iob-16+i] = Jump[i];
       }

    write(BinFileOut,IOBuffer,iob);
    }
  while (total_bytes != rom_size);

  close(BinFileIn);
  close(BinFileOut);
}
